#!C:\Python27\python.exe

# sendfile.py version 1.0.00 - sends a file to the CMM2 over wifi using the esp8266 library
# Written by Rich Martin (datawiz) August 2020
# sendfile.py <mode> <filename>
#  mode 0 - sends file only
#  mode 1 - sends file and tells the cmm2 server to RUN it afterwards
# use with server.bas on the CMM2, can be integrated with an IDE, i.e. Notepad++ on a Windows PC

import socket, sys, os, time
from functools import partial

TCP_IP = '192.168.1.100'		# IP address of your CMM2
TCP_PORT = 6000							# PORT used on your CMM2
BUFFER_SIZE = 1000
CHUNKSIZE = 1400

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
s.connect((TCP_IP,TCP_PORT))
print 'Connected to', TCP_IP
RUNFLAG = sys.argv[1]
FILEPATH = sys.argv[2]
if os.path.isfile(FILEPATH):
	path, fn = os.path.split(FILEPATH)
	size = os.path.getsize(FILEPATH)
	time.sleep(1)
	SENDSTR = "SEND"+sys.argv[1]+","+fn+","+str(size)
	s.send(SENDSTR)
	print("--> "+SENDSTR)
	time.sleep(1)
	with open(FILEPATH, 'rb') as openfileobject:
		for chunk in iter(partial(openfileobject.read, CHUNKSIZE), b''):
			s.send(chunk)
			time.sleep(.5)
	print "Done"
else:
	print("--> Cant open "+FILEPATH+"?")
s.close()


