' server.bas version 1.0.00 - runs as a server on the CMM2 and waits for a file to be sent from a PC client
' to be used with the sendfile.py python file on a PC, Linux, or Mac
' Written by Rich Martin (datawiz) August 2020
'
option explicit
option default none

#include "esp8266var.inc"

dim SERVER_IP$  = ""
dim SERVER_PORT$= "6000"
dim COM_PORT$ = "COM2"
dim COM_SPEED$ = "115200"
dim COM_BUFFER$ = "256"

dim filesize$ = ""
dim filename$ = ""
dim runflag% = 0
dim totalsize%, bytecount%, chunk%
dim x%

cls
open COM_PORT$+":"+COM_SPEED$+","+COM_BUFFER$+",esp.input.loop" as esp.var.com.filenum%

esp.var.echo% = 0
esp.waitfor("AT+CIPSERVER=0","0,CLOSED",esp.waitfor.mode.match%,1)
esp.wifi.escape("AT+CIPCLOSE")
esp.echo.set("OFF")
esp.var.waitfor.mode% = esp.waitfor.mode.normal

BEGIN:
esp.ip.localip
print "] Server started on ";esp.var.waitfor.buffer$;" port ";SERVER_PORT$

esp.var.debug% = 0
esp.tcp.server.begin(SERVER_PORT$)
if esp.var.return$ <> "" then 
  print "] Error starting server, resetting esp8266"
  esp.wifi.restart
  pause 2000
  goto BEGIN
end if 

RESTART:
esp.buffer.clear
runflag% = 0
print
print "] Waiting for client connection, press any key to Quit."
esp.var.timeout% = 1000
do while inkey$ = ""
  esp.waitfor("","0,CONNECT",esp.waitfor.mode.match%,0)
  if esp.var.return$ = "" then goto CONNECT
loop
close esp.var.com.filenum%
end

CONNECT:
esp.var.timeout% = 2000
print "] Client Connected"

esp.waitfor("","",esp.waitfor.mode.mux%,0)
if esp.var.return$ <> "" then print "ERROR!"
if esp.var.return$ = "" then
  if lgetstr$(esp.var.waitfor.buffer.big%(),1,4) = "SEND" then 
    ' get the runflag
    if lgetstr$(esp.var.waitfor.buffer.big%(),5,1) = "1" then runflag% = 1
    ' get the filename
    x% = linstr(esp.var.waitfor.buffer.big%(), ",", 7)
    filename$ = lgetstr$(esp.var.waitfor.buffer.big%(),7, x%-7)
    ' get the filesize
    filesize$ = lgetstr$(esp.var.waitfor.buffer.big%(),x%+1, llen(esp.var.waitfor.buffer.big%())-x%)
    print "] Client is sending ";filename$;" (";filesize$;" total bytes)"
    open filename$ for output as #6
    totalsize% = val(filesize$)
    bytecount% = totalsize%
    ' loop until we get all the bytes of the file
    do
      esp.waitfor("","",esp.waitfor.mode.mux%,0)
      chunk% = llen(esp.var.waitfor.buffer.big%())
      longstring print #6, esp.var.waitfor.buffer.big%();
      bytecount% = bytecount% - chunk%      
      if esp.var.return$ <> "" then print : print "] "esp.var.return$
    loop until bytecount% < 1
    close #6
    print "] File received successfully"
    if runflag% = 1 then 
      copy filename$ to "testrun.bas"
      run "testrun.bas"  
    end if
    goto RESTART
  end if
end if

end

#include "esp8266lib.inc"

